'    Einfacher Rc 2 Kanalschalter
'
'    Autor Dirk Becker
'    Version 1.11
'
'    Dieses Programm Ist Freie Software. Sie Koennen Es Unter Den Bedingungen Der Gnu General Public License,
'    Wie Von Der Free Software Foundation Veroeffentlicht , Weitergeben Und / Oder Modifizieren ,
'    Entweder Gemaess Version 3 Der Lizenz Oder(nach Ihrer Option) Jeder Spaeteren Version.
'
'    Die Verffentlichung dieses Programms erfolgt in der Hoffnung, da es Ihnen von Nutzen sein wird,
'    aber OHNE IRGENDEINE GARANTIE, sogar ohne die implizite Garantie der MARKTREIFE oder der
'    VERWENDBARKEIT FUER EINEN BESTIMMTEN ZWECK. Details finden Sie in der GNU General Public License.
'
'    Sie sollten ein Exemplar der GNU General Public License zusammen mit diesem Programm erhalten haben.
'    Falls nicht, siehe <http://www.gnu.org/licenses/>.
'    Oder auf Deutsch uebersezt <http://www.gnu.de/documents/gpl.de.html>
'
' Pinbelegung des Attiny 13
' Pin1 NC
' Pin2 Signal vom Empfaenger
' Pin3 NC
' Pin4 GND
' Pin5 Schaltkanal1
' Pin6 Schaltkanal2
' Pin7 Led
' Pin8 Vcc


'--- attiny13 -------------------------
$regfile "attiny13.dat"
$crystal = 9600000                                          'Interner Oszillator ohne Teiler
$hwstack = 15
$swstack = 10
$framesize = 15


'---***--- fr Simulator ---***---
'$sim  'Apostophs entfernen
'
'Apostophs beim Pulsein Befehl einfgen
'der Variable Signal, Werte zuweisen
'
'---***---


'Konfiguration der I/O-Ports�s
Config Pinb.3 = Input                                       'Anschluss am Empfaenger Pinb.3
Config Portb.0 = Output                                     'Schaltausgang1
Config Portb.1 = Output                                     'Schaltausgang2
Config Portb.2 = Output                                     'Led kein Signal

Ausgang1 Alias Portb.0
Ausgang2 Alias Portb.1
Led Alias Portb.2
Empfaenger Alias Pinb.3


Dim Signal As Byte                                          'Laenge des Signals vom Empfaenger
Dim S1 As Byte                                              'S1 Wert fuer high Signal                                           '
Dim S2 As Byte                                              'S2 Wert fuer low Signal
Dim K1 As Bit                                               'K1 speichert den Wert von Ausgang1
Dim K2 As Bit                                               'K2 speichert den Wert von Ausgang2



Ausgang1 = 1                                                'Schaltausgang1 aus
Ausgang2 = 1                                                'Schaltausgang2 aus
Led = 1                                                     'Led aus

S1 = 170                                                    'Wert fuer high Signal muss ewentuel angepast werden
S2 = 120                                                    'Wert fuer low Signal muss ewentuel angepast werden
K1 = 0                                                      'Wert fuer Signal und Schaltausgang1
K2 = 0                                                      'Wert fuer Signal und Schaltausgang2



Waitms 250


'Empfaengersignal auswerten-----------------

Do

Messen:

Pulsein Signal , Empfaenger , 3 , 1                         'Signallaenge an Pinb.3 abfragen

If Signal = 0 Then
Gosub Keinsignal

Else
If Signal > S1 Then
Gosub Kanal1                                                'sprung zu Kanal1

Else
If Signal < S2 Then
Gosub Kanal2                                                'sprung zu Kanal2

End If
End If
End If

If Signal < S1 Then                                         'Wert fuer Kanal1 zurueck setzen
K1 = 0
End If

If Signal > S2 Then                                         'Wert fuer Kanal2 zurueck setzen
K2 = 0
End If

Loop

' kein Signal vom Empfaenger----------------

Keinsignal:

Ausgang1 = 1                                                ' Ausgang1 aus
Ausgang2 = 1                                                ' Ausgang2 aus
Led = 0                                                     ' Led an

Waitms 250

Led = 1                                                     ' Led aus

Waitms 250
K1 = 0
K2 = 0

Return


'Abfrage Schaltkanal1----------------------

Kanal1:                                                     '

K2 = 0
If K1 = 1 Then
Return
End If

If Ausgang1 = 1 Then                                        'Ausgang1 einschaltetn und zurueck
Ausgang1 = 0
K1 = 1
Return

Else

Ausgang1 = 1                                                'Ausgang1 ausschaltetn und zurueck
End If
K1 = 1
Return


'Abfrage Schaltkanal2----------------------

Kanal2:

K1 = 0
If K2 = 1 Then
Return
End If

If Ausgang2 = 1 Then                                        'Ausgang2 einschaltetn und zurueck
Ausgang2 = 0
K2 = 1
Return

Else

Ausgang2 = 1                                                'Ausgang2 ausschaltetn und zurueck
End If
K2 = 1
Return

